/*!
 * jQuery.multigrid - A multi-directional grid designed for touch
 * Copyright(c) 2012 Anthony Brooks. <antbrooksuk@gmail.com> and is released under the MIT License: http://www.opensource.org/licenses/mit-license.php
 * http://antbrooksuk.com/
 * http://github.com/antbrooksuk/jQuery.multigrid
 */
(function($){
	"use strict";

		// Grid defaults
		var defaults = {
			random: true,
			centered: true,
			cell_size: 200
		};	
	
		var Grid = function(ul){
			var _i;

			this.cells = ul.find("li").length;
			this.width = Math.floor(Math.sqrt(this.cells)) * defaults.cell_size;
			this.height = Math.floor(Math.sqrt(this.cells)) * defaults.cell_size;
			this.tiles = this.CreateTiles(this.cells);
			
		};
		
		Grid.prototype.CreateTiles = function(cells){
			var _tiles = [];
			for(_i = 0; _i < cells; _i++) {
				_tiles.push(new Tile(ul.find("li")[_i]));
			}	
			return _tiles;
		};

		var Tile = function(li){
			this.colour = this.AssignColour();
		};
		
		Tile.prototype.AssignColour = function(){
			return 'rgb('
				+ (Math.floor(Math.random() * 256)) + ','
				+ (Math.floor(Math.random() * 256)) + ','
				+ (Math.floor(Math.random() * 256)) + ')';
		};

		var init = function(options) {

			var _grid = new Grid($(this).find("ul"));
			console.log(_grid);
/*	
			
			var _grid = $(this).find("ul"),
			// Collection of cells
			_cells = _grid.find("li"),
			// Page width
			_container_width = _grid.width(), 
			// Page height
			_container_height = _grid.height(), 
			// Total number of cells
			_total_cells = _cells.length,
			// Grid size X 
			_x = Math.floor(Math.sqrt(_total_cells)),
			// Grid size Y
			_y,
			_grid_size,
			_top = -(defaults.cell_size),
			_left = -(defaults.cell_size);

			// Caclulate size of the square
			if (_x * _x == _total_cells) {
				_y = _x;
			} else {
				_y = _x + 1;
				if(_x * _y < _total_cells) {
					_x++;
				}
			}

			_grid_size = _x * defaults.cell_size,

			_cells.each(function(i){
				// Random Colour
				var _colour = 'rgb('
					+ (Math.floor(Math.random() * 256)) + ','
					+ (Math.floor(Math.random() * 256)) + ','
					+ (Math.floor(Math.random() * 256)) + ')';

				// Arrange the grid
				_left += defaults.cell_size;

				if(i % _x === 0) {
					_left = 0,
					_top += defaults.cell_size;
				}

				$(this).attr("class", "multigrid-"+i).css({ 
					"backgroundColor": _colour,
					"width": defaults.cell_size,
					"height": defaults.cell_size,
					"left": _left,
					"top": _top
				});
			});

			if(defaults.centered) {
				// Center the grid
				_grid.css({
					width: _grid_size,
					height: _grid_size,
					marginLeft: -(((defaults.cell_size * _x) - _container_width) / 2),
					marginTop: -(((defaults.cell_size * _y) - _container_height) / 2)
				});
			}*/
		};

		$.fn.multigrid = function(options){
			// Careful
			if(!this) {
				return false;
			}
			// Options
			if (typeof options === 'string') {
				$.extend(defaults, options);
			} 
			// go
			init.call(this, options);
			return this;
		};

})(jQuery);